OBGrid Class Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Attributes
OBGrid Class Reference

`#include <openbabel/grid.h>`

Inheritance diagram for OBGrid:
[legend]

List of all members.

## Public Member Functions
| OBGrid ()
virtual void | Init (OBMol &box)
double | GetXmin () const
double | GetYmin () const
double | GetZmin () const
double | GetXmax () const
double | GetYmax () const
double | GetZmax () const
bool | PointIsInBox (double x, double y, double z)
bool | PointIsInBox (double *c)
bool | PointIsInBox (vector3 v)
virtual bool | Clear ()
virtual OBBase * | DoTransformations (const std::map< std::string, std::string > *, OBConversion *)
template<class T >
T * | CastAndClear (bool clear=true)
virtual const char * | GetTitle (bool replaceNewlines=true) const
virtual void | SetTitle (const char *)
Generic data handling methods (via OBGenericData)
bool | HasData (const std::string &)
bool | HasData (const char *)
bool | HasData (const unsigned int type)
void | DeleteData (unsigned int type)
void | DeleteData (OBGenericData *)
void | DeleteData (std::vector< OBGenericData * > &)
bool | DeleteData (const std::string &s)
void | SetData (OBGenericData *d)
void | CloneData (OBGenericData *d)
size_t | DataSize () const
OBGenericData * | GetData (const unsigned int type)
OBGenericData * | GetData (const std::string &)
OBGenericData * | GetData (const char *)
std::vector< OBGenericData * > & | GetData ()
std::vector< OBGenericData * > | GetData (DataOrigin source)
std::vector< OBGenericData * > | GetAllData (const unsigned int type)
OBDataIterator | BeginData ()
OBDataIterator | EndData ()
## Static Public Member Functions
static const char * | ClassDescription ()
## Protected Attributes
double | _xmin
double | _xmax
double | _ymin
double | _ymax
double | _zmin
double | _zmax
std::vector< OBGenericData * > | _vdata

## Detailed Description

A base grid class.

## Constructor & Destructor Documentation

OBGrid | ( |  | ) | `[inline]`

## Member Function Documentation

void Init | ( | OBMol & | box | ) | `[virtual]`

Initialize the grid based on a box around the molecule `box` Subclasses should overload this method -- this only tracks the dimension of the box itself.

double GetXmin | ( |  | ) | const`[inline]`

Returns:
  the minimum x point of the grid

double GetYmin | ( |  | ) | const`[inline]`

Returns:
  the minimum y point of the grid

double GetZmin | ( |  | ) | const`[inline]`

Returns:
  the minimum z point of the grid

double GetXmax | ( |  | ) | const`[inline]`

Returns:
  the maximum x point of the grid

double GetYmax | ( |  | ) | const`[inline]`

Returns:
  the maximum y point of the grid

double GetZmax | ( |  | ) | const`[inline]`

Returns:
  the maximum z point of the grid

bool PointIsInBox | ( | double | x,
|  | double | y,
|  | double | z
| ) |  | `[inline]`

Returns:
  whether the supplied XYZ coordinates fall within the box

bool PointIsInBox | ( | double * | c | ) | `[inline]`

Returns:
  true if the point falls within the box

bool PointIsInBox | ( | vector3 | v | ) | `[inline]`

Returns:
  true if the point falls within the box

bool Clear | ( | void |  | ) | `[virtual, inherited]`

Clear any and all data associated with this object.

This method can be called by OBConversion::Read() before reading data. Derived classes should be sure to call OBBase::Clear() to remove inherited generic data.

Returns:
  Whether the call was successful.

Since:
  version 2.1.

Reimplemented in OBMol, OBAtom, OBReaction, and OBResidue.

Referenced by OBResidue::Clear().

virtual OBBase* DoTransformations | ( | const std::map< std::string, std::string > * | ,
|  | OBConversion * |
| ) |  | `[inline, virtual, inherited]`

Perform a set of transformations specified by the user

Typically these are program options to filter or modify an object For example, see OBMol::DoTransformations() and OBMol::ClassDescription() Base type does nothing

Reimplemented in OBMol.

static const char* ClassDescription | ( |  | ) | `[inline, static, inherited]`

Returns:
  A list of descriptions of command-line options for DoTransformations()

Reimplemented in OBMol, and OBReaction.

T* CastAndClear | ( | bool | clear = `true` | ) | `[inline, inherited]`

By default clears the object. Called from ReadMolecule of most format classes.

virtual const char* GetTitle | ( | bool | replaceNewlines = `true` | ) | const`[inline, virtual, inherited]`

Base type does nothing Made virtual around r3535 to simplify code which passes around OBBase*.

Reimplemented in OBMol.

Referenced by OBMoleculeFormat::DoOutputOptions().

virtual void SetTitle | ( | const char * |  | ) | `[inline, virtual, inherited]`

Reimplemented in OBMol.

Referenced by OBMoleculeFormat::DoOutputOptions().

bool HasData | ( | const std::string & | s | ) | `[inherited]`

Returns:
  whether the generic attribute/value pair exists

Referenced by OBDepict::DrawMolecule(), OBForceField::GetAtomTypes(), OBForceField::GetConformers(), OBForceField::GetCoordinates(), OBMol::GetEnergies(), OBMol::GetEnergy(), OBForceField::GetPartialCharges(), OBDescriptor::MatchPairData(), OBMol::operator=(), OBMoleculeFormat::ReadChemObjectImpl(), and OBMol::SetEnergies().

bool HasData | ( | const char * | s | ) | `[inherited]`

Returns:
  whether the generic attribute/value pair exists

bool HasData | ( | const unsigned int | type | ) | `[inherited]`

Returns:
  whether the generic attribute/value pair exists, for a given OBGenericDataType

void DeleteData | ( | unsigned int | type | ) | `[inherited]`

Delete any data matching the given OBGenericDataType.

Referenced by OpenBabel::CanonicalLabels(), OBDescriptor::DeleteProperties(), and OBMol::RenumberAtoms().

void DeleteData | ( | OBGenericData * | gd | ) | `[inherited]`

Delete the given generic data from this object.

void DeleteData | ( | std::vector< OBGenericData * > & | vg | ) | `[inherited]`

Delete all of the given generic data from this object.

bool DeleteData | ( | const std::string & | s | ) | `[inherited]`

Deletes the generic data with the specified attribute, returning false if not found.

void SetData | ( | OBGenericData * | d | ) | `[inline, inherited]`

Adds a data object; does nothing if d==NULL.

Referenced by OBGastChrg::AssignPartialCharges(), OpenBabel::CalcSignedVolume(), AliasData::Expand(), OBForceField::GetAtomTypes(), OBForceField::GetConformers(), OBForceField::GetCoordinates(), OBMol::GetEnergies(), OBMol::GetEnergy(), OBMol::GetNextFragment(), OBForceField::GetPartialCharges(), OBMoleculeFormat::MakeCombinedMolecule(), OBDescriptor::PredictAndSave(), and OBMol::SetEnergies().

void CloneData | ( | OBGenericData * | d | ) | `[inherited]`

Adds a copy of a data object; does nothing if d == NULL

Since:
  version 2.2

size_t DataSize | ( |  | ) | const`[inline, inherited]`

Returns:
  the number of OBGenericData items attached to this molecule.

OBGenericData * GetData | ( | const unsigned int | type | ) | `[inherited]`

Returns:
  the first matching data for a given type from OBGenericDataType or NULL if nothing matches

Referenced by OpenBabel::CalcSignedVolume(), OpenBabel::CorrectChirality(), OBDepict::DrawMolecule(), AliasData::Expand(), OBDescriptor::FilterCompare(), OpenBabel::GetAtomSymClass(), OBForceField::GetAtomTypes(), OBForceField::GetConformers(), OBForceField::GetCoordinates(), OBMol::GetNextFragment(), OBForceField::GetPartialCharges(), OBDescriptor::GetValues(), OBMoleculeFormat::MakeCombinedMolecule(), OBMolAngleIter::OBMolAngleIter(), OBMolRingIter::OBMolRingIter(), OBMolTorsionIter::OBMolTorsionIter(), OBMol::operator=(), and OBDescriptor::PredictAndSave().

OBGenericData * GetData | ( | const std::string & | s | ) | `[inherited]`

Returns:
  any data matching the given attribute name or NULL if nothing matches
  the value given an attribute name

OBGenericData * GetData | ( | const char * | s | ) | `[inherited]`

Returns:
  any data matching the given attribute name or NULL if nothing matches
  the value given an attribute name

std::vector<OBGenericData*>& GetData | ( |  | ) | `[inline, inherited]`

Returns:
  all data, suitable for iterating

Referenced by OBMol::GetEnergies(), OBMol::GetEnergy(), and OBMol::SetEnergies().

std::vector< OBGenericData * > GetData | ( | DataOrigin | source | ) | `[inherited]`

Returns:
  all data with a specific origin, suitable for iterating

std::vector< OBGenericData * > GetAllData | ( | const unsigned int | type | ) | `[inherited]`

Returns:
  the all matching data for a given type from OBGenericDataType or an empty vector if nothing matches

Since:
  version 2.2

Referenced by OpenBabel::CanonicalLabels(), OBBuilder::CorrectStereoAtoms(), and OBBuilder::CorrectStereoBonds().

OBDataIterator BeginData | ( |  | ) | `[inline, inherited]`

Returns:
  An iterator pointing to the beginning of the data

Referenced by OBMol::AddBond(), OBAtom::Duplicate(), OBMoleculeFormat::MakeCombinedMolecule(), and OBMol::operator=().

OBDataIterator EndData | ( |  | ) | `[inline, inherited]`

Returns:
  An iterator pointing to the end of the data

Referenced by OBMol::AddBond(), OBAtom::Duplicate(), OBMoleculeFormat::MakeCombinedMolecule(), and OBMol::operator=().

## Member Data Documentation

double _xmin`[protected]`

Referenced by OpenBabel::operator<<(), and OpenBabel::operator>>().

double _xmax`[protected]`

Referenced by OpenBabel::operator<<(), and OpenBabel::operator>>().

double _ymin`[protected]`

Referenced by OpenBabel::operator<<(), and OpenBabel::operator>>().

double _ymax`[protected]`

Referenced by OpenBabel::operator<<(), and OpenBabel::operator>>().

double _zmin`[protected]`

Referenced by OpenBabel::operator<<(), and OpenBabel::operator>>().

double _zmax`[protected]`

the min/max axes in XYZ axes (i.e., the box)

Referenced by OpenBabel::operator<<(), and OpenBabel::operator>>().

std::vector<OBGenericData*> _vdata`[protected, inherited]`

Custom data.

Referenced by OBMol::OBMol().

The documentation for this class was generated from the following files:

- grid.h
- grid.cpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines